using System;
using System.Data;
using System.Data.OleDb;
using System.Windows.Forms;

namespace UltraTree_DataBinding_CS
{
	/// <summary>
	/// Summary description for DataHelper.
	/// </summary>
	public class DataHelper
	{
		#region Constructor

		public DataHelper(string databaseFileName)
		{
			this.databaseFileName = databaseFileName;
		}

		#endregion Constructor

		#region Constants

		private const string connectionStringTemplate = @"Provider=Microsoft.Jet.OLEDB.4.0;Password="""";User ID=Admin;Data Source={0};Mode=Read;Extended Properties="""";Jet OLEDB:System database="""";Jet OLEDB:Registry Path="""";Jet OLEDB:Database Password="""";Jet OLEDB:Engine Type=4;Jet OLEDB:Database Locking Mode=0;Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Global Bulk Transactions=1;Jet OLEDB:New Database Password="""";Jet OLEDB:Create System Database=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:SFP=False";
		private const string selectCommandTemplate = "SELECT * FROM [{0}]";

		#endregion //Constants

		#region Private Members

		private OleDbConnection		oleDbConnection = null;	
		private string				databaseFileName = string.Empty;

		#endregion Private Members

		#region Private Methods

		#region DataPath
		/// <summary>
		/// Path to the data installed by the install.
		/// </summary>
		private static string DataPath
		{
			get
			{
				return Infragistics.Samples.Common.DataPath;
			}
		}
		#endregion //DataPath

		#region GetConnectionString

		private string GetConnectionsString(string databaseFileName)
		{
            return string.Format(connectionStringTemplate, System.IO.Path.Combine(DataPath, databaseFileName));
		}

		#endregion GetConnectionString
	
		#endregion Private Methods		

		#region Private Properties

		#region OleDbConnection
		private OleDbConnection	OleDbConnection
		{
			get
			{
				if (this.oleDbConnection == null)
					this.oleDbConnection = new OleDbConnection(GetConnectionsString(databaseFileName));

				return this.oleDbConnection;
			}
		}
		#endregion OleDbConnection		

		#endregion Private Properties

		#region Public Methods

		#region GetTable

		public DataTable GetTable(string tableName)
		{
			try
			{
				string selectCommandText = string.Format(selectCommandTemplate, tableName);
				OleDbDataAdapter dataAdapter = new OleDbDataAdapter(selectCommandText, this.OleDbConnection);
				DataTable table = new DataTable(tableName);
				dataAdapter.Fill(table);
				return table;
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Error getting data");
			}	
		
			return null;
		}

		#endregion GetTable

		#endregion Public Methods
	}
}